/*
	finger.cpp	
	
	Mark B. Elrod
	Sunday August 4th, 1996
	10:45am
	
	Thank you Eric Kidd for the network code base.
	Thank you Be, Inc. for a cool platform.
	
	All rights to this code are given up.
	What little there is here can be used and abused as you see fit ;)
*/

int ParseAddress(char* buffer, char* host, char* name);
char* Finger(char* user, char* hostname);

#pragma mark ## MAIN

main(int argc, char* argv[])
{	
	char host[1000];
	char name[256];
	char* fingerdata = NULL;
	
	if(argc > 1)
	{		
		if(ParseAddress(argv[1], host, name))
		{
			printf("Fingering-> %s\n\n",argv[1]);
			fingerdata = Finger(name, host);
			if(fingerdata)
			{
				printf("%s\n",fingerdata);
				free(fingerdata);
			}
			else
			{
				printf("A network error occurred...\n");
			}
			
		}
		else
		{
			printf("Error parsing the address you requested\n"
			"Should be in the form username@hostname\n"
			"You typed in %s\n",argv[1]);
		}
	}
	else
	{
		printf("You did not type anything stupid!\n");
	}
	
	return(0);
}

int ParseAddress(char* buffer, char* host, char* name)
{
	char* at;
	char* retn;
	
	at = (char*)memchr(buffer,'@',strlen(buffer));
	
	if(!at)
		return 0;
		
	*at = 0x00;
	
	retn = strcpy(name,buffer);
	
	if(!retn)
		return 0;
		
	retn = strcpy(host,at+1);
	
	if(!retn)
		return 0;	
		
	*at = '@';
		
	return 1;
}

char* Finger(char* user, char* hostname)
{
	int a_socket = -1;
	char* buffer = NULL;
	struct sockaddr_in sa_in;
	int retn;
	
	struct hostent* hostent_struct = gethostbyname( hostname );

	if(!hostent_struct)
		return NULL;
		
	// Build address structure
	bzero( (char*) &sa_in, sizeof(struct sockaddr_in) );
	sa_in.sin_family = AF_INET;
	sa_in.sin_port = 79;
	sa_in.sin_addr.s_addr = *((u_long*) hostent_struct->h_addr);
	
	// Open a socket
	a_socket = socket( AF_INET, SOCK_STREAM, 0 );
	if(a_socket < 0)
		return NULL;
	
	// Connect to port
	retn = connect( a_socket, (sockaddr*) &sa_in,
		sizeof(struct sockaddr_in) );
	if(retn < 0)
		return NULL;
	
	// Send user
	
	retn =  send( a_socket, (const char*) user, strlen(user), 0 );
	if(retn < 0)
		return NULL;
		
	retn =  send( a_socket, (const char*) "\r\n", 2, 0 );
	if(retn < 0)
		return NULL;
		
	#define BUFFER_SIZE 2048
	
	buffer = (char*)malloc(BUFFER_SIZE);
	int current_buffer_size = BUFFER_SIZE;
	
	while ( 1 )
	{
		char recv_buffer[1024];
		static int total = 0;
		
		// get finger info
		int count = recv( a_socket, recv_buffer, 1024, 0 );

		
		if ( count > 0 )
		{
			memcpy(buffer + total, recv_buffer,count);
			total += count;
			
			if((current_buffer_size - total) <= 1024)
			{
				buffer = (char*)realloc(buffer,current_buffer_size + 1024);
				current_buffer_size += 1024;
			}
			
		}
		else
		{
			*(buffer + total) = 0x00;
			break;
		}
	}
	
	closesocket(a_socket);
	
	return buffer;
}

